SVN - up to r1895

May, 27, 2010
+ Update translation files
+ Fixed: genie ability, added custom genie ability, rename battle.xml to animations.xml
+ Fixed: blind spell, dwarf magic resist, resurect dead troop
+ Fixed: necromancer morale info
+ Fixed: necromancer skeletons up
+ Fixed: battle catapult targets
+ Updated: diplomacy for surrender and join monster
+ Updated: gameover conditions (WINS_SIDE), added unions (alliance)
+ Added: pocketpc virtual keyboard
+ Fixed: dwelling count with begin week
+ Fixed: World::NewMonth actions
+ Fixed: multiplayer map filter

Apr, 24, 2010
+ Added: extended scouting capability
+ Fixed: manual set hero portrait and class type
+ Fixed: spell duration for magic monsters
+ Fixed: air element + lightning 200% damage
+ Fixed: elemental immunable mind spells
+ Added: groupped/spread battle format
+ Added: hero patrol mode
+ Update: wins/loss game conditions, update game info dialog
+ Added: battle hard skip with +2 defense
+ Fixed: autosave remember settings
+ Fixed: set guardian with last troop
+ Added: pickup artifact scenario messages
+ Added: artifacts affinities HideousMask, StatesmanQuill, CrystalBall, extra settings CrystalBall added spells Visions and IdentifyHero
+ Fixed: broken bridge animation

Apr, 9, 2010
+ Update latest translation files from launchpad
+ Update battle: fixed blind, paralize and stone
+ Added options, battle: skip turn and +2 defence
+ Fixed original version Slow and Haste speed
+ Added check save format
+ Updated battle: added check end battle after tower action
+ Fixed shipyard check
+ Updated battle: added check for probable overflow count troop
+ Added settings: no in-built requirements artifacts
+ Fixed mageguild learn hero
+ Fixed castle building animation
+ Fixed archers attack
+ Added settings: archmage can resists (20%) bad spells, magic creatures can resists (20%) same magic
+ Fixed magic resist troop battle animation
+ Updated captain: added spell book defaults, update captain stats with modificators
+ Fixed morale modificator with end battle
+ Fixed crash, out of range: hero retreat
+ Fixed Battle::Stats::GetCommander Battle::Stats::GetArmy with hypnotize and berzerker
+ Fixed dwelling population with hero present
+ Fixed artifact bar redraw
+ Added check for changes SetGuardians
+ Fixed battle AllowApplySpell without commander, fixed battle obstacle position, fixed Medusa Stone spell duration
+ Fixed archers animation handfighting attack
+ Fixed wagon camp passable sprite
+ Fixed load game and new game state
+ Updated load/save dialogue, added settings: remember last filename
+ Fixed AI magick, shots and move priority
+ Added visited Xanadu update visited shrine, update, name shrine info
+ Added confirm autosave
+ Updated visited witch hut, and name

Mar, 27, 2010
+ Added set guardian for capture objects
+ Fixed obstacles positions for battle, added archers penalty from obstacles
+ Fixed show radar opposite position for hotseat game
+ Updated: main dialogues with yellow color for header
+ Added: customizing value: heroes restore spell points per day, update globals.xml
+ Fixed name objects: Mines, Campfire, update 'Treasure Chest' and 'Sea Chest'
+ Added sorting spell for open book
+ Fixed golem attack sprite direction
+ Fixed shot sound attack
+ Fixed AI spellcast after move
+ Fixed spells 'Town Gate' and 'Town Portal' check other hero present
+ Added ext. info for joining and recruits monster dwellings, for shrine, for resources, witch hut and other
+ Added Symbian port
+ Added polish translation
+ Added more visited info check
+ Fixed whirlpool sprite detect, added customizing wirlpool percent to globals.xml
+ Update objects and artifacts names
+ Added cast spell 'Town Portal'

Mar, 20, 2010
+ Fixed Lightning Bolt damage
+ Added Dialog::Settings
+ Added plural form for monster name
+ Update text, separate context for spell Slow and speed Slow
+ Fixed Necromancy skill ability
+ Added Visions spell, and 'Identify Hero' spell
+ Update dialog scenario, set default params from last game
+ Update show status info: skip empty army
+ Fixed redraw top hero sprite with objects
+ Added 'Haunt' spell
+ Added 'Set Elemental Guardians' spell
+ Added customizing secondary skills
+ Added customization params kingdom::max_heroes
+ Fixed restore spell points from mysticism
+ Fixed 'Standing Stones' secondary visited
+ Fixed starting spell points for recruit heroes
+ Updated AI for double cell attack monsters
+ Updated battle GetDamage algorithm

Mar, 13, 2010
+ Added customizing 'Dimension Door' spell
+ Added spells customizing (spell cost and damage and others params)
+ Fixed casting spell from scroll artifact
+ Fixed Mage and ArchMage battle animation
+ Fixed battle 'Hypnotize' spell and Resurrect Spells apply
+ Fixed battle artifact 'Wizard's Hat' and 'Hourglass'
+ Fixed catapult order destroy objects
+ Added SDL-1.3 build support
+ Fixed "Start with hero in each player.." option
+ Added cast 'Dimension Door', 'Summon Boat', 'Town Gate'
+ Added customizing spells
+ Added pocketpc hardware buttons support

Mar, 7, 2010
+ Fixed joined monster
+ Fixed battle animations
+ Added status message for resurrect spells and death spells
+ Fixed battle necromancy ability
+ Fixed monster magick attack
+ Added bridge animation for battle
+ Fixed battle order speed troop
+ Updated spell action for Battle AI
+ Fixed battle wins/loss music
+ Fixed "mirror image" and "summon elemental" spell for battle
+ Fixed update dwelling population
+ Fixed recruit monster from "water altar " and "eath altar"

Feb, 17, 2010
+ Fixed Coliseum and Storm building ability
+ Added dismiss troop warning and update troop total cost info
+ Fixed game over result for wins_side
+ Fixed move point and spell point for recruit hero
+ Added customizing skill heroes and captain
+ Added customizing buildings, payments costs and profits
+ Added customizing monster stats
+ Added load alternative animation sprite for battle
+ Fixed battle morale
+ Fixed dublicate maps directory
+ Updated grown monsters on maps, fixed genie initial count
+ Fixed pyramid action
+ Fixed distrupting ray spell animation, fixed battle yellow status
+ Fixed start dialogues for loaded game
+ Fixed battle morale with skip turn
+ Fixed battle archers

Feb, 8, 2010
+ Fixed catapult animation
+ Added battle ai mass spell action
+ Fixed moat path restriction
+ Updates speed animations
+ Added system info (free memory, time for pocketpc)
+ Fixed config read
+ Updated new battle logic

Jan, 29, 2010
+ Added new battle engine, QVGA support
+ Fixed spells lasting past the end of a battle
+ Fixed spells lasting indefinitely in battle
+ Fixed monsters casting spells on dead units
+ Added heroes path store
+ Fixed hot seat crash
+ Fixed redistribute army
+ Fixed spell book filter

Nov, 27, 2009
+ fixed multiple pickup maps event
+ fixed sounds in battle being clipped. Stop battle music at end of battle summary.
+ added new mixer code, alternative sound load update code, reduce memory usage

Nov, 8, 2009
+ fixed heroes fadein/fadeout
+ fixed multiple maps event
+ update mixer
+ added options alt resource, support ogg sounds
+ added options hide ai move
+ fixed obelisk action, updated open puzzle algorithm
+ added builtin icon (mingw32, mingw32ce)
+ update artifact Arm of the Martyr
+ added artifact Spell Scroll
+ fixed heroes action (meetings/battle) with other heroes (shipmaster)
+ added rescan path for heroes with new day
+ added check full bag artifacts for heroes;
+ added ActionToTravelersTent and ActionToBarrier
+ fixed battle: fix flag, fix count troop visible
+ fixed 65k count for battle troop

Oct,  22, 2009 - Development build, 1299
+ Updated size army for heroes/castles info
+ Updated save file format version
+ Updated AI move, fix redraw status window
+ Added support translation for name and description maps, maps messages
+ Fixed recruit hero with empty army
+ Fixed restore magic point for heroes
+ Added tap delay settings, update high scores dialogue
+ Added buy magic book for pocketpc version
+ Fixed capture abandoned mine, add AI action abandoned mine
+ Fixed AI move midi cd music
+ Added store high scores and update high scores dialogue
+ Added force lang options
+ Added translation for original map files (sign, rumors, events message, sphinx riddle)
+ Added emulation the right mouse button for tap mode
+ Added low memory actions
+ Update pocketpc dialogues
+ Fixed more problems with troops moving too close in battle.
+ Keep battle win/lose music from looping. Play the puzzle music when not using midi.
+ Fixed incorrect battle results being displayed when battling AI.
+ Fixed trolls starting with much more health than they should in battle.
+ Fixed various problems in battle causing troops to attack from too far away.

Oct,  7, 2009 - Development build, 1235
+ Fixed for Battle: DrawShadow and DrawCell support 8 bit for default depth, fast move cursor for battle scene, fix left click for move current troop, set cursor WAR_NONE after kick
+ added puzzle dialogue for pocketpc version, fix for redraw heroes move
+ added binary save format
+ few updates for pocketpc version
+ added buy boat and marketplace dialogue for pocketpc
+ added tap mode and offset pointer settings for pocketpc (one touch as mouse click)

Developers
+ added WITHOUT_EDITOR, WITHOUT_ZLIB and WITHOUT_XML build options

Sep, 28, 2009 - Development build, 1210
+ More updates for pocketpc version

Sep, 17, 2009 - Development build, 1195

Users
+ Added pocketpc version interface
+ Added load fheroes2.cfg and gamedata from FHEROES2_DATA environment
+ Added new options: "use fade = on/off", "hide interface = on/off"
+ Added add hot key: m - move hero, o - system dialog, n - start new game
+ Added new interface: hide interface
+ Fixed performance, (remove delay from pathfinding)
+ Fixed castle resource panel
+ Fixed visit obelisk
+ Fixed building for differences plathorm (OSX, mingw32, wince)
+ Fixed Abandoned Mine name, add extra text in quick info.
+ Added zlib support for xml save files
+ Update music readme with more specific information.
+ Update translation files from launchpad

Developers
+ Added CONFIGURE_FHEROES2_DATA build defines for gamedata
+ Added WITHOUT_MIXER build option
+ Redistribute main loop game_startgame.cpp, move radar, buttons, status to interface gui, other small changes.

May 30, 2009 - Development build r1117

Users
+ Memory usage reductions.
+ Fixed various battle summary window glitches.
+ Fixed numerous errors with multi-cell attacks (dragons, cyclopes, etc).
+ Corrected logic error causing AI units to believe they could attack when they
  shouldn't, and vice versa.
+ Added game over conditions.
+ Added puzzle piece fading effect.
+ Creatures can now receive morale boosts when not attacking.
+ Fixed text for recruiting free monster dwellings.
+ Fixed incorrect logic for halving damage through castle walls.
+ Fixed rare siuation in battle when ranged troops think they are performing a
  melee attack even if they are not.
+ Fixed starting resource for AI.
+ Enabled key repeating.
+ Hero path arrows now reflect movement penalties.
+ Double clicking on an entry in a file selection box will choose that item.
+ Added Spanish translation.
+ Multiple events can now occur on the same day.
+ Fixed bug causing obelisks not to be counted past the first visited,
  causing maps like Dragon Rider to now work.
+ Fixed music restarting with every step taken by a player's hero.
+ Fixed relatively rare crash involving the AI and ranged units in battle,
  most obvious in the opening turn of Dragon Rider.
+ If a hero is attacked while in a castle, a castle battle is now initiated,
  and as many troops as possible in the castle's army are moved into the
  defending hero's army.

Developers
+ SDL_Mixer music and sound callbacks removed, as they were potentially dangerous
  as used.

April 23, 2009 - Development build r1021

Users
+ Added glowing outlines around currently selected monster in battles.
+ Battle victory/defeat music now plays properly when viewing the summary.
+ Races are no longer grayed out on the scenario panel when restarting a game.
+ All units in battle now deal a minimum of 1 damage, with damage modifiers
  now capped at -30% and 300% as specified in the original manual.
+ Heroes may no longer surrender to non-heroes.
+ Removed 'Upgrade' and 'Dismiss' buttons from monster info dialogs in battle.
+ Fixed bug causing enemy corpses to resurrect with 65000 units.
+ Heroes now receive experience corresponding to amount of damage dealt in battles,
  and the new number displays properly in the summary dialog.
+ Extra income is no longer received on the first day of the game.
+ Added support for Eagle Eye and Necromancy skills.
+ Elves and Rangers will no longer perform hand to hand combat attacks twice.
+ Screenshots now save to files/screenshot_[time].(png|bmp)
+ Starting monster stack sizes are now more in line with Heroes II defaults.
+ Added an info window in the status bar when collecting resources.
+ Added support for Diplomacy skill: monsters will now offer to join you
  if your army is powerful enough.
+ Saving and loading of games has been implemented, as has autosave
  (configured in fheroes2.cfg)
+ Fixed various bugs with heroes learning spells when entering a castle
  and class-specific starting spells. 
+ Fixed a bug in which the computer would take over certain battles in which
  a hero or captain was not present. This fixes the map Revolution, among others.
+ The keep and towers will now deal appropriate damage in castle battles.
+ Battle status messages are now visible for longer.
+ Heroes now level up at game start as they do in HoMM II.
+ Fixed a bug causing heroes to gain levels in multiple primary skills on levelup.
+ Genies now have 9% chance to halve the size of any troop attacked in battle.
+ Ghosts gain 1 unit for every unit they kill.
+ Pathfinding will now avoid tiles which would trigger a battle.

Developers
+ Added wrapper library around SDL_net and networking client/server examples.
+ Added support for replacing ICN files at runtime with other images.

March 19, 2009 - Development build r915

Users
+ Added Russian translation .po file.
+ Added actions for Mermaids, Sirens, Arenas, Stables, Barrow Mounds, Elemental Recruiting, Jails, HutMagi,
  EyeMagi, and Sphinxes.
+ Added load and save game support.
+ AI battles now use battle system logic to properly decide outcomes.
+ Added support for castle and town battles.
+ Arrow keys now move the current hero, while CTRL+arrow scrolls the map view.  

Developers
+ Removed libxml2 dependence
+ Added build options (WITHOUT_PNG, WITHOUT_UNICODE)
+ Battle engine rewritten to separate logic from display, and to allow
  for future expansion (ie. castles/towns).
+ Added gettext support.
+ Unicode support with TTF font render.

February 1, 2009 - Development build r850

Users
+ Added icn2png convertor tools
+ Campfires now give gold rewards along with other resources. (afletdinov)
+ Numeric fields now accept keyboard input. (afletdinov)
+ Black Dragons now correctly cost 2 sulphur. (afletdinov)
+ Artifacts with resource costs are now fixed, instead of changing randomly
  each time a hero touches the artifact. (afletdinov)
+ Fixed maps generating the same random artifact multiple times. (afletdinov)
+ Added actions for Tree of Knowledge, Oracle, and Demon Cave map objects. (afletdinov)
+ Fixed various endian issues which made fheroes2 unplayable on AmigaOS. (afletdinov)
+ Added keyboard hotkeys for buttons on the main menu and ending the turn in game.
  (afletdinov, revvy)

Developers

+ Nothing.

December 25, 2008 - Development build r807

Users

+ Heroes now level up and learn new skills based on race tables from
  HoMM II.  (afletdinov)
+ Wide monsters in battle now properly reflect in place, fixing a number of
  overlapping troop bugs. (revvy)
+ Animation speed on the main adventure screen can now be controlled from the
  settings panel in game. (afletdinov)
+ Added animations for previously static objects (stone liths, treasure chests,
  fountains). (afletdinov)
+ Added rudimentary AI for castle building, recruiting troops and controlling
  heroes. (afletdinov)
+ Stopped end turn confirmation dialog from appearing when all heroes cannot
  move any further along their paths, but still have movement points
  remaining. (revvy)
+ Added music to Barbarian castle. (afletdinov)
+ Tiles surrounding a monster on the adventure screen now show the battle
  mouse cursor. (afletdinov)
+ Battle summary screen no longer misses some captured artifacts. (revvy)
+ Added ultimate artifact puzzle interface. (revvy, afletdinov)
+ Fixed a bug preventing remaining HP information from showing up in the monster
  info window in battle. (revvy)
+ Fixed recurring problem in battles where AI units would walk next to a unit
  but not attack. (revvy)
+ Fixed bug causing marketplace dialog to close after every trade. (revvy)
+ Fixed various problems with dialogs being slightly transparent and very ugly.
  (afletdinov, revvy)
+ Fixed bug causing experience award display on battle summary screen to
  always show 0. (revvy)
+ Tiles surrounding monsters on the adventure screen now display the proper
  fight cursor. (afletdinov)
+ All major dialogs should respond like HoMM II to ESC and RET key presses.
  (afletdinov)
+ Message boxes now display the title in proper yellow letters. (afletdinov)
+ Monsters now properly draw in front of scenery and other monsters while
  moving in battle. (revvy)
+ Many more bug fixes.

Developers

+ Army::Troops has been split into Army::Troop (for storing monster type, total
  number, and primary skill) and Army::BattleTroop, which holds information
  about animation, hit points, and position. (revvy)
+ Fixed a couple endian issues, so fheroes2 should theoretically work perfectly
  on MacOS (revvy, afletdinov)

November 20, 2008 - Development build r571

+ Everything!
